#!/usr/bin/python3
# -*- coding: utf-8 -*-
#
# This file is part of Pulse 2, http://www.siveo.net
#
# Pulse 2 is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Pulse 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Pulse 2; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

import sys
import os
import logging
import configparser
import netifaces
import random
import json
import hashlib
from optparse import OptionParser
import traceback
import time
import urllib.request
import signal
from threading import Thread
import imp

logger = logging.getLogger()
if sys.version_info < (3, 0):
    imp.reload(sys)
    sys.setdefaultencoding("utf8")
else:
    raw_input = input
maxthread = 0
nbthread = 0
globaltest = """
<?xml version="1.0" encoding="UTF-8"?>
<REQUEST>
  <CONTENT>
    <ACCESSLOG>
      <LOGDATE>2019-04-16 09:35:42</LOGDATE>
    </ACCESSLOG>
    <BIOS>
      <ASSETTAG/>
      <BDATE>12/01/2006</BDATE>
      <BMANUFACTURER>innotek GmbH</BMANUFACTURER>
      <BVERSION>VirtualBox</BVERSION>
      <MMANUFACTURER>Oracle Corporation</MMANUFACTURER>
      <MMODEL>VirtualBox</MMODEL>
      <MSN>0</MSN>
      <SKUNUMBER/>
      <SMANUFACTURER>innotek GmbH</SMANUFACTURER>
      <SMODEL>VirtualBox</SMODEL>
      <SSN>F15E46B2-BB07-4496-8BDE-C033763239D3</SSN>
    </BIOS>
    <CONTROLLERS>
      <CAPTION>440FX - 82441FX PMC [Natoma]</CAPTION>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>440FX - 82441FX PMC [Natoma]</NAME>
      <PCICLASS>0600</PCICLASS>
      <PCISLOT>00:00.0</PCISLOT>
      <PRODUCTID>1237</PRODUCTID>
      <REV>02</REV>
      <TYPE>Host bridge</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82371SB PIIX3 ISA [Natoma/Triton II]</CAPTION>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82371SB PIIX3 ISA [Natoma/Triton II]</NAME>
      <PCICLASS>0601</PCICLASS>
      <PCISLOT>00:01.0</PCISLOT>
      <PRODUCTID>7000</PRODUCTID>
      <TYPE>ISA bridge</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>VirtualBox Graphics Adapter</CAPTION>
      <MANUFACTURER>InnoTek Systemberatung GmbH</MANUFACTURER>
      <NAME>VirtualBox Graphics Adapter</NAME>
      <PCICLASS>0300</PCICLASS>
      <PCISLOT>00:02.0</PCISLOT>
      <PRODUCTID>beef</PRODUCTID>
      <TYPE>VGA compatible controller</TYPE>
      <VENDORID>80ee</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82540EM Gigabit Ethernet Controller</CAPTION>
      <DRIVER>e1000</DRIVER>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82540EM Gigabit Ethernet Controller</NAME>
      <PCICLASS>0200</PCICLASS>
      <PCISLOT>00:03.0</PCISLOT>
      <PRODUCTID>100e</PRODUCTID>
      <REV>02</REV>
      <TYPE>Ethernet controller</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>VirtualBox Guest Service</CAPTION>
      <MANUFACTURER>InnoTek Systemberatung GmbH</MANUFACTURER>
      <NAME>VirtualBox Guest Service</NAME>
      <PCICLASS>0880</PCICLASS>
      <PCISLOT>00:04.0</PCISLOT>
      <PRODUCTID>cafe</PRODUCTID>
      <TYPE>System peripheral</TYPE>
      <VENDORID>80ee</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82371AB/EB/MB PIIX4 ACPI</CAPTION>
      <DRIVER>piix4_smbus</DRIVER>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82371AB/EB/MB PIIX4 ACPI</NAME>
      <PCICLASS>0680</PCICLASS>
      <PCISLOT>00:07.0</PCISLOT>
      <PRODUCTID>7113</PRODUCTID>
      <REV>08</REV>
      <TYPE>Bridge</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82540EM Gigabit Ethernet Controller</CAPTION>
      <DRIVER>e1000</DRIVER>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82540EM Gigabit Ethernet Controller</NAME>
      <PCICLASS>0200</PCICLASS>
      <PCISLOT>00:08.0</PCISLOT>
      <PRODUCTID>100e</PRODUCTID>
      <REV>02</REV>
      <TYPE>Ethernet controller</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82540EM Gigabit Ethernet Controller</CAPTION>
      <DRIVER>e1000</DRIVER>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82540EM Gigabit Ethernet Controller</NAME>
      <PCICLASS>0200</PCICLASS>
      <PCISLOT>00:09.0</PCISLOT>
      <PRODUCTID>100e</PRODUCTID>
      <REV>02</REV>
      <TYPE>Ethernet controller</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CONTROLLERS>
      <CAPTION>82801HM/HEM (ICH8M/ICH8M-E) SATA Controller [AHCI mode]</CAPTION>
      <DRIVER>ahci</DRIVER>
      <MANUFACTURER>Intel Corporation</MANUFACTURER>
      <NAME>82801HM/HEM (ICH8M/ICH8M-E) SATA Controller [AHCI mode]</NAME>
      <PCICLASS>0106</PCICLASS>
      <PCISLOT>00:0d.0</PCISLOT>
      <PRODUCTID>2829</PRODUCTID>
      <REV>02</REV>
      <TYPE>SATA controller</TYPE>
      <VENDORID>8086</VENDORID>
    </CONTROLLERS>
    <CPUS>
      <ARCH>i386</ARCH>
      <CORE>1</CORE>
      <FAMILYNUMBER>6</FAMILYNUMBER>
      <MANUFACTURER>Intel</MANUFACTURER>
      <MODEL>142</MODEL>
      <NAME>Intel(R) Core(TM) i7-7500U CPU @ 2.70GHz</NAME>
      <SPEED>2700</SPEED>
      <STEPPING>9</STEPPING>
      <THREAD>1</THREAD>
    </CPUS>
    <DRIVES>
      <FILESYSTEM>ext4</FILESYSTEM>
      <FREE>5954</FREE>
      <SERIAL>dab3bf26-1dc9-4363-8670-df1e543009fb</SERIAL>
      <TOTAL>8907</TOTAL>
      <TYPE>/</TYPE>
      <VOLUMN>/dev/sda1</VOLUMN>
    </DRIVES>
    <ENVS>
      <KEY>SSH_CLIENT</KEY>
      <VAL>192.168.56.1 47884 22</VAL>
    </ENVS>
    <ENVS>
      <KEY>HOME</KEY>
      <VAL>/root</VAL>
    </ENVS>
    <ENVS>
      <KEY>SSH_CONNECTION</KEY>
      <VAL>192.168.56.1 47884 192.168.56.27 22</VAL>
    </ENVS>
    <ENVS>
      <KEY>PATH</KEY>
      <VAL>/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin</VAL>
    </ENVS>
    <ENVS>
      <KEY>PWD</KEY>
      <VAL>/usr/lib/python2.7/dist-packages/pulse_xmpp_agent</VAL>
    </ENVS>
    <ENVS>
      <KEY>USER</KEY>
      <VAL>root</VAL>
    </ENVS>
    <ENVS>
      <KEY>XDG_RUNTIME_DIR</KEY>
      <VAL>/run/user/0</VAL>
    </ENVS>
    <ENVS>
      <KEY>TERM</KEY>
      <VAL>xterm-256color</VAL>
    </ENVS>
    <ENVS>
      <KEY>SSH_TTY</KEY>
      <VAL>/dev/pts/0</VAL>
    </ENVS>
    <ENVS>
      <KEY>DBUS_SESSION_BUS_ADDRESS</KEY>
      <VAL>unix:path=/run/user/0/bus</VAL>
    </ENVS>
    <ENVS>
      <KEY>SHELL</KEY>
      <VAL>/bin/bash</VAL>
    </ENVS>
    <ENVS>
      <KEY>_</KEY>
      <VAL>/usr/bin/python</VAL>
    </ENVS>
    <ENVS>
      <KEY>LANG</KEY>
      <VAL>en_US.UTF-8</VAL>
    </ENVS>
    <ENVS>
      <KEY>XDG_SESSION_ID</KEY>
      <VAL>24</VAL>
    </ENVS>
    <ENVS>
      <KEY>LOGNAME</KEY>
      <VAL>root</VAL>
    </ENVS>
    <ENVS>
      <KEY>SHLVL</KEY>
      <VAL>1</VAL>
    </ENVS>
    <ENVS>
      <KEY>MAIL</KEY>
      <VAL>/var/mail/root</VAL>
    </ENVS>
    <FIREWALL>
      <STATUS>off</STATUS>
    </FIREWALL>
    <HARDWARE>
      <CHASSIS_TYPE>Other</CHASSIS_TYPE>
      <CHECKSUM>131071</CHECKSUM>
      <DATELASTLOGGEDUSER>Tue Apr 16 07:15</DATELASTLOGGEDUSER>
      <DEFAULTGATEWAY>10.0.2.2</DEFAULTGATEWAY>
      <DNS>10.0.2.3</DNS>
      <IPADDR>10.0.2.15/192.168.56.27</IPADDR>
      <LASTLOGGEDUSER>root</LASTLOGGEDUSER>
      <MEMORY>996</MEMORY>
      <NAME>MACHINE_TEST_BENCKMARK</NAME>
      <OSCOMMENTS>#1 SMP Debian 4.9.30-2+deb9u5 (2017-09-19)</OSCOMMENTS>
      <OSNAME>Debian GNU/Linux 9 (stretch)</OSNAME>
      <OSVERSION>4.9.0-3-amd64</OSVERSION>
      <PROCESSORN>1</PROCESSORN>
      <PROCESSORS>2700</PROCESSORS>
      <PROCESSORT>Intel(R) Core(TM) i7-7500U CPU @ 2.70GHz</PROCESSORT>
      <SWAP>1021</SWAP>
      <USERID>root</USERID>
      <UUID>F15E46B2-BB07-4496-8BDE-C033763239D3</UUID>
      <VMSYSTEM>VirtualBox</VMSYSTEM>
    </HARDWARE>
    <INPUTS>
      <CAPTION>AT Translated Set 2 keyboard</CAPTION>
      <DESCRIPTION>AT Translated Set 2 keyboard</DESCRIPTION>
      <TYPE>sysrq</TYPE>
    </INPUTS>
    <INPUTS>
      <CAPTION>ImExPS/2 Generic Explorer Mouse</CAPTION>
      <DESCRIPTION>ImExPS/2 Generic Explorer Mouse</DESCRIPTION>
      <TYPE>Pointing</TYPE>
    </INPUTS>
    <INPUTS>
      <CAPTION>Video Bus</CAPTION>
      <DESCRIPTION>Video Bus</DESCRIPTION>
      <TYPE>Keyboard</TYPE>
    </INPUTS>
    <INPUTS>
      <CAPTION>PC Speaker</CAPTION>
      <DESCRIPTION>PC Speaker</DESCRIPTION>
      <TYPE>Keyboard</TYPE>
    </INPUTS>
    <LOCAL_GROUPS>
      <ID>24</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>cdrom</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>25</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>floppy</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>27</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>sudo</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>29</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>audio</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>30</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>dip</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>44</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>video</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>46</ID>
      <MEMBER>vagrant</MEMBER>
      <MEMBER>usbmux</MEMBER>
      <NAME>plugdev</NAME>
    </LOCAL_GROUPS>
    <LOCAL_GROUPS>
      <ID>108</ID>
      <MEMBER>vagrant</MEMBER>
      <NAME>netdev</NAME>
    </LOCAL_GROUPS>
    <LOCAL_USERS>
      <HOME>/root</HOME>
      <ID>0</ID>
      <LOGIN>root</LOGIN>
      <NAME>root</NAME>
      <SHELL>/bin/bash</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/usr/sbin</HOME>
      <ID>1</ID>
      <LOGIN>daemon</LOGIN>
      <NAME>daemon</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/bin</HOME>
      <ID>2</ID>
      <LOGIN>bin</LOGIN>
      <NAME>bin</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/dev</HOME>
      <ID>3</ID>
      <LOGIN>sys</LOGIN>
      <NAME>sys</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/bin</HOME>
      <ID>4</ID>
      <LOGIN>sync</LOGIN>
      <NAME>sync</NAME>
      <SHELL>/bin/sync</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/usr/games</HOME>
      <ID>5</ID>
      <LOGIN>games</LOGIN>
      <NAME>games</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/cache/man</HOME>
      <ID>6</ID>
      <LOGIN>man</LOGIN>
      <NAME>man</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/spool/lpd</HOME>
      <ID>7</ID>
      <LOGIN>lp</LOGIN>
      <NAME>lp</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/mail</HOME>
      <ID>8</ID>
      <LOGIN>mail</LOGIN>
      <NAME>mail</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/spool/news</HOME>
      <ID>9</ID>
      <LOGIN>news</LOGIN>
      <NAME>news</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/spool/uucp</HOME>
      <ID>10</ID>
      <LOGIN>uucp</LOGIN>
      <NAME>uucp</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/bin</HOME>
      <ID>13</ID>
      <LOGIN>proxy</LOGIN>
      <NAME>proxy</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/www</HOME>
      <ID>33</ID>
      <LOGIN>www-data</LOGIN>
      <NAME>www-data</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/backups</HOME>
      <ID>34</ID>
      <LOGIN>backup</LOGIN>
      <NAME>backup</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/list</HOME>
      <ID>38</ID>
      <LOGIN>list</LOGIN>
      <NAME>Mailing List Manager</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/run/ircd</HOME>
      <ID>39</ID>
      <LOGIN>irc</LOGIN>
      <NAME>ircd</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/gnats</HOME>
      <ID>41</ID>
      <LOGIN>gnats</LOGIN>
      <NAME>Gnats Bug-Reporting System (admin)</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/nonexistent</HOME>
      <ID>65534</ID>
      <LOGIN>nobody</LOGIN>
      <NAME>nobody</NAME>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/run/systemd</HOME>
      <ID>100</ID>
      <LOGIN>systemd-timesync</LOGIN>
      <NAME>systemd Time Synchronization,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/run/systemd/netif</HOME>
      <ID>101</ID>
      <LOGIN>systemd-network</LOGIN>
      <NAME>systemd Network Management,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/run/systemd/resolve</HOME>
      <ID>102</ID>
      <LOGIN>systemd-resolve</LOGIN>
      <NAME>systemd Resolver,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/run/systemd</HOME>
      <ID>103</ID>
      <LOGIN>systemd-bus-proxy</LOGIN>
      <NAME>systemd Bus Proxy,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/nonexistent</HOME>
      <ID>104</ID>
      <LOGIN>_apt</LOGIN>
      <NAME/>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/run/dbus</HOME>
      <ID>105</ID>
      <LOGIN>messagebus</LOGIN>
      <NAME/>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/run/sshd</HOME>
      <ID>106</ID>
      <LOGIN>sshd</LOGIN>
      <NAME/>
      <SHELL>/usr/sbin/nologin</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/home/vagrant</HOME>
      <ID>1000</ID>
      <LOGIN>vagrant</LOGIN>
      <NAME>Vagrant Default User,,,</NAME>
      <SHELL>/bin/bash</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/pulse2/</HOME>
      <ID>1001</ID>
      <LOGIN>pulse</LOGIN>
      <NAME/>
      <SHELL>/bin/rbash</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/pulse2</HOME>
      <ID>107</ID>
      <LOGIN>pulseuser</LOGIN>
      <NAME/>
      <SHELL>/bin/rbash</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/syncthing</HOME>
      <ID>1002</ID>
      <LOGIN>syncthing</LOGIN>
      <NAME/>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/usbmux</HOME>
      <ID>108</ID>
      <LOGIN>usbmux</LOGIN>
      <NAME>usbmux daemon,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/proc</HOME>
      <ID>109</ID>
      <LOGIN>rtkit</LOGIN>
      <NAME>RealtimeKit,,,</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/var/lib/lightdm</HOME>
      <ID>110</ID>
      <LOGIN>lightdm</LOGIN>
      <NAME>Light Display Manager</NAME>
      <SHELL>/bin/false</SHELL>
    </LOCAL_USERS>
    <LOCAL_USERS>
      <HOME>/home/jfk</HOME>
      <ID>1003</ID>
      <LOGIN>jfk</LOGIN>
      <NAME>jfk,,,</NAME>
      <SHELL>/bin/bash</SHELL>
    </LOCAL_USERS>
    <NETWORKS>
      <DESCRIPTION>lo</DESCRIPTION>
      <IPADDRESS>127.0.0.1</IPADDRESS>
      <IPMASK>255.0.0.0</IPMASK>
      <IPSUBNET>127.0.0.0</IPSUBNET>
      <MACADDR>00:00:00:00:00:00</MACADDR>
      <STATUS>Up</STATUS>
      <TYPE>loopback</TYPE>
      <VIRTUALDEV>1</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>lo</DESCRIPTION>
      <IPADDRESS6>::1</IPADDRESS6>
      <IPMASK6>fff0::</IPMASK6>
      <IPSUBNET6>::</IPSUBNET6>
      <MACADDR>00:00:00:00:00:00</MACADDR>
      <STATUS>Up</STATUS>
      <TYPE>loopback</TYPE>
      <VIRTUALDEV>1</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>eth0</DESCRIPTION>
      <DRIVER>e1000</DRIVER>
      <IPADDRESS>10.0.2.15</IPADDRESS>
      <IPGATEWAY>10.0.2.2</IPGATEWAY>
      <IPMASK>255.255.255.0</IPMASK>
      <IPSUBNET>10.0.2.0</IPSUBNET>
      <MACADDR>08:00:27:d0:2b:75</MACADDR>
      <PCIID>8086:100E:8086:001E</PCIID>
      <PCISLOT>0000:00:03.0</PCISLOT>
      <SPEED>1000</SPEED>
      <STATUS>Up</STATUS>
      <TYPE>ethernet</TYPE>
      <VIRTUALDEV>0</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>eth0</DESCRIPTION>
      <DRIVER>e1000</DRIVER>
      <IPADDRESS6>fe80::a00:27ff:fed0:2b75</IPADDRESS6>
      <IPMASK6>ffff:ffff:ffff:ffff::</IPMASK6>
      <IPSUBNET6>fe80::</IPSUBNET6>
      <MACADDR>08:00:27:d0:2b:75</MACADDR>
      <PCIID>8086:100E:8086:001E</PCIID>
      <PCISLOT>0000:00:03.0</PCISLOT>
      <SPEED>1000</SPEED>
      <STATUS>Up</STATUS>
      <TYPE>ethernet</TYPE>
      <VIRTUALDEV>0</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>eth1</DESCRIPTION>
      <DRIVER>e1000</DRIVER>
      <IPADDRESS>192.168.56.27</IPADDRESS>
      <IPMASK>255.255.255.0</IPMASK>
      <IPSUBNET>192.168.56.0</IPSUBNET>
      <MACADDR>08:00:27:4f:11:e1</MACADDR>
      <PCIID>8086:100E:8086:001E</PCIID>
      <PCISLOT>0000:00:08.0</PCISLOT>
      <SPEED>1000</SPEED>
      <STATUS>Up</STATUS>
      <TYPE>ethernet</TYPE>
      <VIRTUALDEV>0</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>eth1</DESCRIPTION>
      <DRIVER>e1000</DRIVER>
      <IPADDRESS6>fe80::a00:27ff:fe4f:11e1</IPADDRESS6>
      <IPMASK6>ffff:ffff:ffff:ffff::</IPMASK6>
      <IPSUBNET6>fe80::</IPSUBNET6>
      <MACADDR>08:00:27:4f:11:e1</MACADDR>
      <PCIID>8086:100E:8086:001E</PCIID>
      <PCISLOT>0000:00:08.0</PCISLOT>
      <SPEED>1000</SPEED>
      <STATUS>Up</STATUS>
      <TYPE>ethernet</TYPE>
      <VIRTUALDEV>0</VIRTUALDEV>
    </NETWORKS>
    <NETWORKS>
      <DESCRIPTION>eth2</DESCRIPTION>
      <DRIVER>e1000</DRIVER>
      <MACADDR>08:00:27:42:f3:ae</MACADDR>
      <PCIID>8086:100E:8086:001E</PCIID>
      <PCISLOT>0000:00:09.0</PCISLOT>
      <SPEED>1000</SPEED>
      <STATUS>Down</STATUS>
      <TYPE>ethernet</TYPE>
      <VIRTUALDEV>0</VIRTUALDEV>
    </NETWORKS>
    <OPERATINGSYSTEM>
      <ARCH>x86_64</ARCH>
      <BOOT_TIME>2019-04-16 06:03:07</BOOT_TIME>
      <DNS_DOMAIN>siveo.net</DNS_DOMAIN>
      <FQDN>MACHINE_TEST_BENCKMARK.siveo.net</FQDN>
      <FULL_NAME>Debian GNU/Linux 9 (stretch)</FULL_NAME>
      <HOSTID>007f0100</HOSTID>
      <KERNEL_NAME>linux</KERNEL_NAME>
      <KERNEL_VERSION>4.9.0-3-amd64</KERNEL_VERSION>
      <NAME>Debian GNU/Linux</NAME>
      <SSH_KEY>ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIEcokCvee0FCdo+PItXeghM12FJiSUIN1iuPAL4+SI5r</SSH_KEY>
      <TIMEZONE>
        <NAME>GMT</NAME>
        <OFFSET>+0000</OFFSET>
      </TIMEZONE>
      <VERSION>9 (stretch)</VERSION>
    </OPERATINGSYSTEM>
    <PROCESSES>
      <CMD>/sbin/init</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>1</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>56952</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kthreadd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>2</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[ksoftirqd/0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>3</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/0:0H]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>5</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/u2:0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>6</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[rcu_sched]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>7</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[rcu_bh]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>8</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[migration/0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>9</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[lru-add-drain]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>10</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[watchdog/0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>11</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[cpuhp/0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>12</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kdevtmpfs]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>13</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[netns]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>14</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[khungtaskd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>15</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[oom_reaper]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>16</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[writeback]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>17</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kcompactd0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>18</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[ksmd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>19</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[khugepaged]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>21</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[crypto]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>22</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kintegrityd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>23</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>24</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kblockd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>25</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[devfreq_wq]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>26</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[watchdogd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>27</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kswapd0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>28</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[vmstat]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>29</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kthrotld]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>41</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[ipv6_addrconf]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>42</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[ata_sff]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>75</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>76</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>79</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>81</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>82</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>84</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>86</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>88</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>90</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/u2:1]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>91</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[scsi_eh_0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>111</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[scsi_tmf_0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>112</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[bioset]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>113</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/0:1H]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>115</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[jbd2/sda1-8]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>149</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[ext4-rsv-conver]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>150</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd-journald</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>179</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>48652</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kauditd]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>181</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd-udevd</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>213</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>46040</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd-timesyncd</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>223</PID>
      <STARTED>2019-04-16 06:03</STARTED>
      <TTY>?</TTY>
      <USER>systemd+</USER>
      <VIRTUALMEMORY>127284</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/rtkit/rtkit-daemon</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.2</MEM>
      <PID>304</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>rtkit</USER>
      <VIRTUALMEMORY>185748</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/sbin/rsyslogd -n</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.2</MEM>
      <PID>305</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>250116</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd-logind</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>306</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>46496</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/bin/dbus-daemon --system --address=systemd: --nofork --nopidfile --systemd-activation</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.3</MEM>
      <PID>307</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>message+</USER>
      <VIRTUALMEMORY>45248</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/sbin/dhclient -4 -v -pf /run/dhclient.eth0.pid -lf /var/lib/dhcp/dhclient.eth0.leases -I -df /var/lib/dhcp/dhclient6.eth0.leases eth0</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.1</MEM>
      <PID>330</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>20468</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/sbin/cron -f</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.2</MEM>
      <PID>339</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>29636</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/sbin/agetty --noclear tty1 linux</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.1</MEM>
      <PID>373</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>tty1</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>14536</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/sbin/lightdm</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>376</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>289828</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/sbin/sshd -D</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>387</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>69944</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/xorg/Xorg :0 -seat seat0 -auth /var/run/lightdm/root/:0 -nolisten tcp vt7 -novtswitch</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>4.4</MEM>
      <PID>390</PID>
      <STARTED>2019-04-16 06:04</STARTED>
      <TTY>tty7</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>364948</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>lightdm --session-child 18 21</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>453</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>233156</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd --user</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>456</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>64976</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>(sd-pam)</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.1</MEM>
      <PID>457</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>84536</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/sbin/lightdm-gtk-greeter</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>6.3</MEM>
      <PID>461</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>673640</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/at-spi2-core/at-spi-bus-launcher --launch-immediately</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.5</MEM>
      <PID>463</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>348672</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/bin/dbus-daemon --session --address=systemd: --nofork --nopidfile --systemd-activation</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.3</MEM>
      <PID>468</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>44992</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/bin/dbus-daemon --config-file=/usr/share/defaults/at-spi2/accessibility.conf --nofork --print-address 3</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.3</MEM>
      <PID>470</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>44992</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/at-spi2-core/at-spi2-registryd --use-gnome-session</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.5</MEM>
      <PID>472</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>220316</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/gvfs/gvfsd</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.5</MEM>
      <PID>474</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>lightdm</USER>
      <VIRTUALMEMORY>284196</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>lightdm --session-child 14 21</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>485</PID>
      <STARTED>2019-04-16 06:06</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>87496</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/udisks2/udisksd --no-debug</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.7</MEM>
      <PID>849</PID>
      <STARTED>2019-04-16 06:32</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>375296</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/lib/policykit-1/polkitd --no-debug</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>853</PID>
      <STARTED>2019-04-16 06:32</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>286136</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>sshd: root@pts/0</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.6</MEM>
      <PID>1285</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>99304</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/lib/systemd/systemd --user</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.5</MEM>
      <PID>1287</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>56404</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>(sd-pam)</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.1</MEM>
      <PID>1288</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>84536</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>-bash</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.4</MEM>
      <PID>1296</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>20924</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>python /usr/lib/python2.7/dist-packages/pulse_xmpp_agent/launcher.py -c -t machine</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>1.5</MEM>
      <PID>1302</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>47988</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>sh -c python agentxmpp.py -c -t machine</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>1307</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>4288</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>python agentxmpp.py -c -t machine</CMD>
      <CPUUSAGE>0.4</CPUUSAGE>
      <MEM>5.6</MEM>
      <PID>1308</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>630492</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/usr/bin/syncthing -no-browser -no-restart -logflags=0</CMD>
      <CPUUSAGE>0.1</CPUUSAGE>
      <MEM>2.3</MEM>
      <PID>1318</PID>
      <STARTED>2019-04-16 07:15</STARTED>
      <TTY>?</TTY>
      <USER>syncthi+</USER>
      <VIRTUALMEMORY>52092</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/0:0]</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>1395</PID>
      <STARTED>2019-04-16 07:37</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>[kworker/0:2]</CMD>
      <CPUUSAGE>0.1</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>2347</PID>
      <STARTED>2019-04-16 09:14</STARTED>
      <TTY>?</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>0</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>/bin/sh -c fusioninventory-agent --local=/tmp/inventory.txt</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.0</MEM>
      <PID>2604</PID>
      <STARTED>2019-04-16 09:35</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>4288</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>fusioninventory-agent: running task Inventory</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>4.9</MEM>
      <PID>2605</PID>
      <STARTED>2019-04-16 09:35</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>168832</VIRTUALMEMORY>
    </PROCESSES>
    <PROCESSES>
      <CMD>ps -A -o user,pid,pcpu,pmem,vsz,tty,etime,command</CMD>
      <CPUUSAGE>0.0</CPUUSAGE>
      <MEM>0.2</MEM>
      <PID>2616</PID>
      <STARTED>2019-04-16 09:35</STARTED>
      <TTY>pts/0</TTY>
      <USER>root</USER>
      <VIRTUALMEMORY>36636</VIRTUALMEMORY>
    </PROCESSES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>849</FILESIZE>
      <FROM>deb</FROM>
      <NAME>adduser</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.115</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>28418</FILESIZE>
      <FROM>deb</FROM>
      <NAME>adwaita-icon-theme</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.22.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3539</FILESIZE>
      <FROM>deb</FROM>
      <NAME>apt</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.4.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>368</FILESIZE>
      <FROM>deb</FROM>
      <NAME>apt-listchanges</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>3.10</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>apt-transport-https</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.4.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1099</FILESIZE>
      <FROM>deb</FROM>
      <NAME>apt-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.4.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>410</FILESIZE>
      <FROM>deb</FROM>
      <NAME>at-spi2-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2.22.0-6+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>333</FILESIZE>
      <FROM>deb</FROM>
      <NAME>base-files</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>9.9+deb9u5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>229</FILESIZE>
      <FROM>deb</FROM>
      <NAME>base-passwd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.5.43</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>5798</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bash</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>shells</SYSTEM_CATEGORY>
      <VERSION>4.4-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1220</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bash-completion</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>shells</SYSTEM_CATEGORY>
      <VERSION>1:2.1-4.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>232</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>math</SYSTEM_CATEGORY>
      <VERSION>1.06.95-9+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>312</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bind9-host</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>23353</FILESIZE>
      <FROM>deb</FROM>
      <NAME>binutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>2.28-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>566</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bsdmainutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>9.0.12+nmu1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>238</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bsdutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>20</FILESIZE>
      <FROM>deb</FROM>
      <NAME>build-essential</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>12.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>729</FILESIZE>
      <FROM>deb</FROM>
      <NAME>busybox</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:1.22.0-19+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>184</FILESIZE>
      <FROM>deb</FROM>
      <NAME>bzip2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.0.6-8.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>434</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ca-certificates</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>20161130+nmu1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>201212</FILESIZE>
      <FROM>deb</FROM>
      <NAME>chromium</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>73.0.3683.75-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>482</FILESIZE>
      <FROM>deb</FROM>
      <NAME>console-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.7.89</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2444</FILESIZE>
      <FROM>deb</FROM>
      <NAME>console-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2:1.12-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>437</FILESIZE>
      <FROM>deb</FROM>
      <NAME>console-setup</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.164</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>console-setup-linux</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.164</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>15103</FILESIZE>
      <FROM>deb</FROM>
      <NAME>coreutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>8.26-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>720</FILESIZE>
      <FROM>deb</FROM>
      <NAME>cpio</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.11+dfsg-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>41</FILESIZE>
      <FROM>deb</FROM>
      <NAME>cpp</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>interpreters</SYSTEM_CATEGORY>
      <VERSION>4:6.3.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>22665</FILESIZE>
      <FROM>deb</FROM>
      <NAME>cpp-6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>interpreters</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>251</FILESIZE>
      <FROM>deb</FROM>
      <NAME>cron</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.0pl1-128+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>204</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dash</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>shells</SYSTEM_CATEGORY>
      <VERSION>0.5.8-2.4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>532</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dbus</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.10.26-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>110</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dbus-user-session</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.10.26-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>136</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dbus-x11</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.10.26-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>72</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dconf-gsettings-backend</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.26.0-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>105</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dconf-service</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.26.0-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>558</FILESIZE>
      <FROM>deb</FROM>
      <NAME>debconf</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.5.61</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>780</FILESIZE>
      <FROM>deb</FROM>
      <NAME>debconf-i18n</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>1.5.61</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>118</FILESIZE>
      <FROM>deb</FROM>
      <NAME>debian-archive-keyring</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2017.5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1277</FILESIZE>
      <FROM>deb</FROM>
      <NAME>debian-faq</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>8.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>213</FILESIZE>
      <FROM>deb</FROM>
      <NAME>debianutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>4.8.1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>8083</FILESIZE>
      <FROM>deb</FROM>
      <NAME>desktop-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>9.0.2+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>267</FILESIZE>
      <FROM>deb</FROM>
      <NAME>desktop-file-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>0.23-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>402</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dh-python</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.20170125</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>757</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dictionaries-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>1.27.2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1327</FILESIZE>
      <FROM>deb</FROM>
      <NAME>diffutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:3.5-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>90</FILESIZE>
      <FROM>deb</FROM>
      <NAME>discover</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.1.2-7.1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4392</FILESIZE>
      <FROM>deb</FROM>
      <NAME>discover-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.2013.01.11</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>15</FILESIZE>
      <FROM>deb</FROM>
      <NAME>distro-info-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>0.36</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>190</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dmidecode</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>3.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>236</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dmsetup</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2:1.02.137-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>166</FILESIZE>
      <FROM>deb</FROM>
      <NAME>doc-debian</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>6.4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>235</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dosfstools</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>otherosfs</SYSTEM_CATEGORY>
      <VERSION>4.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>6778</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dpkg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.18.25</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1874</FILESIZE>
      <FROM>deb</FROM>
      <NAME>dpkg-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.18.25</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>449</FILESIZE>
      <FROM>deb</FROM>
      <NAME>e2fslibs</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.43.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4022</FILESIZE>
      <FROM>deb</FROM>
      <NAME>e2fsprogs</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.43.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>229</FILESIZE>
      <FROM>deb</FROM>
      <NAME>eject</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.1.5+deb1+cvs20081104-13.2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>136</FILESIZE>
      <FROM>deb</FROM>
      <NAME>emacsen-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>editors</SYSTEM_CATEGORY>
      <VERSION>2.0.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>70</FILESIZE>
      <FROM>deb</FROM>
      <NAME>exfat-fuse</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>otherosfs</SYSTEM_CATEGORY>
      <VERSION>1.2.5-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>exfat-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>otherosfs</SYSTEM_CATEGORY>
      <VERSION>1.2.5-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>289</FILESIZE>
      <FROM>deb</FROM>
      <NAME>exo-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.10.7-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>215</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fakeroot</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.21-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>file</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:5.30-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1854</FILESIZE>
      <FROM>deb</FROM>
      <NAME>findutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>4.6.0+git+20161106-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>29</FILESIZE>
      <FROM>deb</FROM>
      <NAME>flake8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.2.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>530</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fontconfig</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>2.11.0-6.7+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>420</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fontconfig-config</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>2.11.0-6.7</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2954</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fonts-dejavu-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>2.37-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>7345</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fonts-droid-fallback</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:6.0.1r16-1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2093</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fonts-liberation</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:1.07.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>144</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fonts-noto-mono</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>20161116-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>226</FILESIZE>
      <FROM>deb</FROM>
      <NAME>freerdp-x11</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>136</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fuse</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.9.7-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1580</FILESIZE>
      <FROM>deb</FROM>
      <NAME>fusioninventory-agent</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:2.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>15</FILESIZE>
      <FROM>deb</FROM>
      <NAME>g++</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>4:6.3.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>23930</FILESIZE>
      <FROM>deb</FROM>
      <NAME>g++-6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>43</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gcc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>4:6.3.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>25114</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gcc-6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>209</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gcc-6-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>746</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gdisk</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.0.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>6841</FILESIZE>
      <FROM>deb</FROM>
      <NAME>geoip-database</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>20170512-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>718</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gettext-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.19.8.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>225</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ghostscript</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>9.20~dfsg-3.2+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>622</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gir1.2-glib-2.0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>introspection</SYSTEM_CATEGORY>
      <VERSION>1.50.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>174</FILESIZE>
      <FROM>deb</FROM>
      <NAME>glib-networking</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>416</FILESIZE>
      <FROM>deb</FROM>
      <NAME>glib-networking-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>38</FILESIZE>
      <FROM>deb</FROM>
      <NAME>glib-networking-services</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>6706</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnome-accessibility-themes</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.22.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>15204</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnome-icon-theme</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.12.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>525</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnome-themes-standard</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.22.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>987</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnome-themes-standard-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.22.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2088</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnupg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.1.18-8~deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1362</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnupg-agent</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.1.18-8~deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1385</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnupg1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.4.21-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>104</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnupg1-curl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.4.21-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3541</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gnupg1-l10n</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.4.21-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>721</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gpgv</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.1.18-8~deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1131</FILESIZE>
      <FROM>deb</FROM>
      <NAME>grep</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.27-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3261</FILESIZE>
      <FROM>deb</FROM>
      <NAME>groff-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>1.22.3-9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>14768</FILESIZE>
      <FROM>deb</FROM>
      <NAME>grub-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.02~beta3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>561</FILESIZE>
      <FROM>deb</FROM>
      <NAME>grub-pc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.02~beta3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2906</FILESIZE>
      <FROM>deb</FROM>
      <NAME>grub-pc-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.02~beta3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1151</FILESIZE>
      <FROM>deb</FROM>
      <NAME>grub2-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.02~beta3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3809</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gsettings-desktop-schemas</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>gnome</SYSTEM_CATEGORY>
      <VERSION>3.22.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4439</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gsfonts</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>1:8.11+urwcyr1.0.7~pre44-4.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2736</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gstreamer1.0-plugins-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.10.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>139</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gtk-update-icon-cache</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>3.22.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>110</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gtk2-engines-pixbuf</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>graphics</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>421</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gtk2-engines-xfce</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>3.2.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>358</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gvfs</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.30.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3989</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gvfs-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.30.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>475</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gvfs-daemons</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.30.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>421</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gvfs-libs</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.30.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>231</FILESIZE>
      <FROM>deb</FROM>
      <NAME>gzip</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.6-5+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>hdparm</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>9.51+ds-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>414</FILESIZE>
      <FROM>deb</FROM>
      <NAME>hicolor-icon-theme</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>0.15-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>47</FILESIZE>
      <FROM>deb</FROM>
      <NAME>hostname</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.18+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>76</FILESIZE>
      <FROM>deb</FROM>
      <NAME>hwdata</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>0.290-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2099</FILESIZE>
      <FROM>deb</FROM>
      <NAME>i965-va-driver</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>video</SYSTEM_CATEGORY>
      <VERSION>1.7.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>203</FILESIZE>
      <FROM>deb</FROM>
      <NAME>iamerican</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>3.4.00-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>203</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ibritish</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>3.4.00-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>58</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ienglish-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>3.4.00-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>195</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ifupdown</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>0.8.19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>19</FILESIZE>
      <FROM>deb</FROM>
      <NAME>init</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>metapackages</SYSTEM_CATEGORY>
      <VERSION>1.48</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>131</FILESIZE>
      <FROM>deb</FROM>
      <NAME>init-system-helpers</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.48</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>105</FILESIZE>
      <FROM>deb</FROM>
      <NAME>initramfs-tools</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.130</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>210</FILESIZE>
      <FROM>deb</FROM>
      <NAME>initramfs-tools-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.130</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>43</FILESIZE>
      <FROM>deb</FROM>
      <NAME>installation-report</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2.62</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1757</FILESIZE>
      <FROM>deb</FROM>
      <NAME>iproute2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>4.9.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1528</FILESIZE>
      <FROM>deb</FROM>
      <NAME>iptables</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1.6.0+snapshot20161117-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>111</FILESIZE>
      <FROM>deb</FROM>
      <NAME>iputils-ping</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>3:20161105-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>649</FILESIZE>
      <FROM>deb</FROM>
      <NAME>isc-dhcp-client</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>4.3.5-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>141</FILESIZE>
      <FROM>deb</FROM>
      <NAME>isc-dhcp-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>4.3.5-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>17495</FILESIZE>
      <FROM>deb</FROM>
      <NAME>iso-codes</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>3.75-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>356</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ispell</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>3.4.00-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>68</FILESIZE>
      <FROM>deb</FROM>
      <NAME>javascript-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>11</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1632</FILESIZE>
      <FROM>deb</FROM>
      <NAME>kbd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.0.3-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2451</FILESIZE>
      <FROM>deb</FROM>
      <NAME>keyboard-configuration</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.164</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>384</FILESIZE>
      <FROM>deb</FROM>
      <NAME>klibc-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.4-9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>220</FILESIZE>
      <FROM>deb</FROM>
      <NAME>kmod</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>23-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>302</FILESIZE>
      <FROM>deb</FROM>
      <NAME>krb5-locales</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>18</FILESIZE>
      <FROM>deb</FROM>
      <NAME>laptop-detect</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.13.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>277</FILESIZE>
      <FROM>deb</FROM>
      <NAME>less</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>481-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>122</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libaacs0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.8.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>62</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libacl1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.2.52-3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>108</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libalgorithm-diff-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.19.03-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>44</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libalgorithm-diff-xs-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.04-4+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>43</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libalgorithm-merge-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.08-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>140</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libapparmor1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.11.0-3+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>470</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libapt-inst2.0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3056</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libapt-pkg5.0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1259</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasan3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1303</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasound2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>632</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasound2-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.3-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>299</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasound2-plugins</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>50</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasprintf0v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.19.8.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>106</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libassuan0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>39</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libasyncns0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.8-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>72</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatasmart4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.19-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>213</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatk-bridge2.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.22.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>212</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatk1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.22.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1221</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatk1.0-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2.22.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>334</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatkmm-1.6-1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>41</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatomic1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>217</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libatspi2.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.22.0-6+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>42</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libattr1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.4.47-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>30</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libaudit-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.6.7-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>150</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libaudit1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.6.7-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>155</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libauthen-sasl-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.1600-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>120</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavahi-client3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.32-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>755</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavahi-common-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.32-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>105</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavahi-common3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.32-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>12984</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavcodec57</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7:3.2.12-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2383</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavformat57</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7:3.2.12-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>230</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavresample3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7:3.2.12-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>544</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libavutil55</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7:3.2.12-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>119</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libbdplus0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>253</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libbind9-140</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>367</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libblkid1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>341</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libbluray1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:0.9.3-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>163</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libbsd0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.8.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libbz2-1.0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.6-8.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3365</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libc-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>377</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libc-dev-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4210</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libc-l10n</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>10684</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libc6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>15628</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libc6-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>387</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcairo-gobject2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.14.8-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1464</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcairo2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.14.8-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>202</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcairomm-1.0-1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcanberra-gtk3-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.30-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>47</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcanberra-gtk3-module</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.30-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>119</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcanberra0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.30-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>43</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcap-ng0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.7.7-3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>47</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcap2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.25-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>85</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcap2-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:2.25-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>87</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcc1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>109</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcdparanoia0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.10.2+debian-11</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>101</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libchromaprint1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>143</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcilkrts5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>53</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libclass-isa-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.36-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>525</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcolord2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>83</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcomerr2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.43.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>329</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcroco3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.11-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>217</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcryptsetup4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.7.3-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>135</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcrystalhd3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:0.0~git20110715.fdd2f19-12</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>689</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcups2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.2.1-8+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>227</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcupsfilters1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.11.6-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>155</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcupsimage2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.2.1-8+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>616</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libcurl3-gnutls</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7.52.1-5+deb9u7</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>72</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdatrie1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.10-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1814</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdb5.3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>5.3.28-12+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>448</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdbus-1-3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.10.26-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>335</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdbus-glib-1-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>oldlibs</SYSTEM_CATEGORY>
      <VERSION>0.108-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>91</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdconf1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.26.0-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>67</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdebconfclient0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.227</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>401</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdevmapper1.02.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.02.137-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>128</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdigest-sha-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>5.96-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>257</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdiscover2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.2-7.1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2119</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdns-export162</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4255</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdns162</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2273</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdpkg-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.18.25</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>77</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdrm-amdgpu1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.74-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>181</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdrm-intel1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.74-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>72</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdrm-nouveau2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.74-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>85</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdrm-radeon1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.74-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>105</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libdrm2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.74-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>241</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libedit2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.1-20160903-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>275</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libegl1-mesa</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>934</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libelf1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.168-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>34</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libencode-locale-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.05-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1124</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libepoxy0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>32</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libestr0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.10-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>86</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libev4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:4.22-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>124</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libevdev2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.5.6+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>341</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libevent-2.0-5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.21-stable-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1983</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexif12</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.21-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2192</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexo-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.10.7-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>167</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexo-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.10.7-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>248</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexo-helpers</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.10.7-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>369</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexpat1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.2.0-2+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>851</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libexpat1-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.2.0-2+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>150</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfakeroot</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.21-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>62</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfastjson4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.99.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>469</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfdisk1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libffi6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.2.1-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-basedir-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.07-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>49</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-desktopentry-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.22-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>126</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-fcntllock-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.22-3+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-listing-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.04-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>113</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-mimeinfo-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.27-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>32</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfile-which-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.21-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>520</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libflac8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>70</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfont-afm-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.20-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>486</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfontconfig1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.11.0-6.7+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>57</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfontenc1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.3-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>245</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-cache1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>368</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-client1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>358</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-codec1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>243</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-common1.1.0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>732</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-core1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>273</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-crypto1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>315</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-gdi1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>365</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-locale1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>616</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-plugins-standard</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>240</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-primitives1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>231</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-rail1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>249</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreerdp-utils1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>898</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfreetype6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.6.3-3.2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>341</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libfuse2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.9.7-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>443</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgail-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgail18</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>240</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgarcon-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>755</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgarcon-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>116</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgbm1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>355</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgc1c2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:7.4.2-8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>12766</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgcc-6-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>108</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgcc1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>251</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgck-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.20.0-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>41</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgcr-3-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.20.0-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>653</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgcr-base-3-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.20.0-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1266</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgcrypt20</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.7.6-2+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>68</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgdbm3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.8.3-14</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>534</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgdk-pixbuf2.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.36.5-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2539</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgdk-pixbuf2.0-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.36.5-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>240</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgeoip1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.9-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>243</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgirepository-1.0-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.50.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>113473</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgl1-mesa-dri</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>551</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgl1-mesa-glx</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>246</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libglapi-mesa</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4999</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libglib2.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>9461</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libglib2.0-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2551</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libglibmm-2.4-1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.50.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>464</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libglu1-mesa</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>9.0.0-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>329</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgme0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.6.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>568</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgmp10</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:6.1.2+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>228</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgnutls-openssl27</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.5.8-5+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2429</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgnutls30</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.5.8-5+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>203</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgomp1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>572</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgpg-error0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.26-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>60</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgpm2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.20.4-6.2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>212</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgraphite2-3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.10-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>15901</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgs9</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>9.20~dfsg-3.2+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>7384</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgs9-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>9.20~dfsg-3.2+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>73</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgsm1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.13-4+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>423</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgssapi-krb5-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>87</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgssglue1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>234</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgssrpc4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3626</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgstreamer-plugins-base1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.10.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4742</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgstreamer1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.10.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>9005</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk-3-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.22.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>284</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk-3-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>3.22.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>24183</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk-3-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>3.22.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>5734</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk2.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>68</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk2.0-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>19928</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtk2.0-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>2.24.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>6178</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgtkmm-3.0-1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.22.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libgudev-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>230-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1072</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libharfbuzz0b</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>232</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhogweed4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.3-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>89</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhtml-form-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.03-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>129</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhtml-format-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>229</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhtml-parser-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>3.72-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>32</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhtml-tagset-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>3.20-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>489</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhtml-tree-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>5.03-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>76</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhttp-cookies-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.01-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>71</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhttp-daemon-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.01-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhttp-date-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.02-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>184</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhttp-message-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>76</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libhttp-negotiate-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.00-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>915</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libical2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.0-0.5+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>134</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libice6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.9-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>30038</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libicu57</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>57.1-6+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>306</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libidn11</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.33-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>174</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libidn2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.16-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>48</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libijs-0.35</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.35-12</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>181</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libimobiledevice6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2.0+dfsg-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>48</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libinput-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libinput10</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libio-html-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.001-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>504</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libio-socket-ssl-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.044-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>110</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libip4tc0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.0+snapshot20161117-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>114</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libip6tc0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.0+snapshot20161117-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>63</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libipc-system-simple-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.25-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>88</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libiptc0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.0+snapshot20161117-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libirs141</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>603</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libisc-export160</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1118</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libisc160</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>234</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libisccc140</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>351</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libisccfg140</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1864</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libisl15</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.18-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>127</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libitm1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1100</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjack-jackd2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.9.10+20150825git1ed50c92~dfsg-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>78</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjbig0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1-3.1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>162</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjbig2dec0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.13-4.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>477</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjpeg62-turbo</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.5.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>551</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjs-jquery</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>3.1.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>129</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjs-sphinxdoc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>1.4.9-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>251</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjs-underscore</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>1.8.3~dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>300</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjson-glib-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>526</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libjson-glib-1.0-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>311</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libk5crypto3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>201</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkadm5clnt-mit11</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>230</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkadm5srv-mit11</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>178</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkdb5-8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>35</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkeybinder-3.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.3.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>36</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkeyutils1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.5.9-9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>105</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libklibc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.4-9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>116</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkmod2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>23-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>147</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkrad0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1026</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkrb5-3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>159</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libkrb5support0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.15-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>264</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libksba8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.5-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>404</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblcms2-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.8-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>509</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libldap-2.4-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.44+dfsg-5+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>108</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libldap-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.44+dfsg-5+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>141</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblightdm-gobject-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>1.18.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>44958</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libllvm3.9</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:3.9.1-9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>51</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblocale-gettext-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.07-3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>45</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblockfile-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.14-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblockfile1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.14-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>38</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblogging-stdlog0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.5-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>158</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblognorm5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.1-1.1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>308</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblsan0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>417</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libltdl7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.6-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>100</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblwp-mediatypes-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.02-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblwp-protocol-https-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.06-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>269</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblwres141</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:9.10.3.dfsg.P4-12.3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>93</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblz4-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.0~r131-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>339</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liblzma5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>5.2.2-1.2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4832</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmagic-mgc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:5.30-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>214</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmagic1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:5.30-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>212</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmailtools-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.18-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4255</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmariadbclient18</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>10.1.26-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>64</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libminizip1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1-8+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>46</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmnl0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>403</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmount1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>533</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmp3lame0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.99.5+repack1-9+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>111</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmpc3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.3-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>254</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmpdec2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>824</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmpfr4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.1.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>351</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmpg123-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.23.8-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>46</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmpx2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libmtdev1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.5-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>287</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libncurses5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>347</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libncursesw5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>241</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-cups-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.63-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>612</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-dbus-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.1.0-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>62</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-http-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>134</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-ip-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.26-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>20</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-smtp-ssl-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.04-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1124</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnet-ssleay-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.80-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>134</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnetfilter-conntrack3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.6-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>48</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnetfilter-cthelper0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>358</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnettle6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.3-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>372</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnewt0.52</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.52.19-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>61</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnfnetlink0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>103</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnfsidmap2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.25-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>201</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnghttp2-14</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.18.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>34</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnotify-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.7.7-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>58</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnotify4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.7.7-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>43</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnpth0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>331</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnspr4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:4.12-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3766</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnss3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:3.26.2-1.1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>362</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libntfs-3g871</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2016.2.22AR.1+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>78</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libnuma1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.0.11-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>76</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libogg0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>306</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libopenjp2-7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.2-1.1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1322</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libopenmpt0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.7386~beta20.3-3+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>333</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libopus0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2~alpha2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>561</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liborc-0.4-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:0.4.26-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>438</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libp11-kit0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.23.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam-cap</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.25-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>874</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam-modules</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.1.8-3.6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>220</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam-modules-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.1.8-3.6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1016</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam-runtime</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.1.8-3.6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>369</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam-systemd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>229</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpam0g</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.8-3.6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>547</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpango-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.40.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpangocairo-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.40.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>275</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpangoft2-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.40.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpangomm-1.4-1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.40.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpaper-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.1.24+nmu5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>61</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpaper1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.24+nmu5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>74</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libparse-edid-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.0.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>504</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libparted2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.2-17</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>102</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpci3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:3.5.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>92</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpciaccess0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.13.4-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>668</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpcre3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:8.39-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>95</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpcsclite1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.8.20-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>20931</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libperl5.24</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>5.24.1-3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>75</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpipeline1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>984</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpixman-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.34.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>86</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libplist3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12+git+1+e37ca00-0.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>413</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpng16-16</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.28-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>64</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpolkit-agent-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.105-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>131</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpolkit-backend-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.105-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>146</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpolkit-gobject-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.105-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>436</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpoppler-glib8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.48.0-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3219</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpoppler64</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.48.0-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>224</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpopt0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.16-10+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>61</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libproc-daemon-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.23-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>103</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libproc-processtable-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.53-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>121</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libprocps6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:3.3.12-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>159</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libproxy1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4.14-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>73</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpsl5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.17.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>109</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpulse-mainloop-glib0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>sound</SYSTEM_CATEGORY>
      <VERSION>10.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>977</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpulse0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>10.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>132</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpulsedsp</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>sound</SYSTEM_CATEGORY>
      <VERSION>10.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>6</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython-all-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>42</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython-dbg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>debug</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>42</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>37</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython-stdlib</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3565</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython2.7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>25348</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython2.7-dbg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>debug</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40659</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython2.7-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2767</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython2.7-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>8550</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython2.7-stdlib</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>36</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython3-stdlib</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3747</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython3.5-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>9896</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libpython3.5-stdlib</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>265</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libquadmath0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>549</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libre2-3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>20170101+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>416</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libreadline7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>111</FILESIZE>
      <FROM>deb</FROM>
      <NAME>librest-0.7-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.8.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>87</FILESIZE>
      <FROM>deb</FROM>
      <NAME>librpcsecgss3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.19-7+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>429</FILESIZE>
      <FROM>deb</FROM>
      <NAME>librsvg2-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.40.16-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>211</FILESIZE>
      <FROM>deb</FROM>
      <NAME>librsvg2-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.40.16-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>142</FILESIZE>
      <FROM>deb</FROM>
      <NAME>librtmp1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.4+20151223.gitfa8646d.1-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1482</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsamplerate0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.8-8+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>183</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsasl2-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.27~101-g0780600+dfsg-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>259</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsasl2-modules</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.27~101-g0780600+dfsg-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsasl2-modules-db</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.27~101-g0780600+dfsg-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>293</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libseccomp2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.3.1-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>354</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsecret-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.18.5-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>209</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsecret-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.18.5-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>209</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libselinux1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.6-3+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>39</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsemanage-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.6-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>291</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsemanage1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.6-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>118</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsensors4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:3.4.0-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>653</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsepol1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.6-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>68</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libshine3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.1.0-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>97</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsigc++-2.0-0v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.10.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1566</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libslang2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.3.1-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>64</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsm6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.2.2-1+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>257</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsmartcols1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>81</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsnappy1v5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.3-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>573</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsndfile1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.27-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>88</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsocket-getaddrinfo-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.22-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>35</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsoup-gnome2.4-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.56.0-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1050</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsoup2.4-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.56.0-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>201</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsoxr0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>117</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libspeex1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2~rc1.2-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>91</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libspeexdsp1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2~rc1.2-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1162</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsqlite3-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>3.16.2-5+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>95</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libss2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.43.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>504</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libssh-gcrypt-4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.7.3-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>262</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libssh2-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.7.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3547</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libssl1.0.2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.2l-2+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3525</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libssl1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0f-3+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>69</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libstartup-notification0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.12-4+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>14894</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libstdc++-6-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libdevel</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1998</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libstdc++6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>76</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libswitch-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.17-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>222</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libswresample2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7:3.2.12-1~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>653</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libsystemd0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>112</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtasn1-6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.10-1.1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>114</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtdb1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.11-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>40</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtext-charwidth-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.04-7+b5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>50</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtext-iconv-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.7-5+b4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>140</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtext-template-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.46-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>26</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtext-wrapi18n-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.06-7.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>601</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libthai-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.26-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>94</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libthai0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.1.26-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>731</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtheora0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.1+dfsg.1-14+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>245</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libthunarx-2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>34</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtie-ixhash-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.23-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>587</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtiff5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.0.8-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtimedate-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.3000-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>478</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtinfo5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>219</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtirpc1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.5-1.2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1122</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtokyocabinet9</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.48-11+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>908</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtsan0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>123</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtumbler-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.1.31-2+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>144</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtwolame0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.3.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>247</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libtxc-dxtn-s2tc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0+git20151227-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>292</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libubsan0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>6.3.0-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>223</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libudev1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>485</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libudisks2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1.8-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1144</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libunistring0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.9.6+really0.9.3-0.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>52</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libuniversal-require-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.17-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>194</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libupower-glib3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.99.4-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>228</FILESIZE>
      <FROM>deb</FROM>
      <NAME>liburi-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.71-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>57</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libusb-0.1-4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:0.1.12-30</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>134</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libusb-1.0-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.21-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>51</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libusbmuxd4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.10-3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>258</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libustr-1.0-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.0.4-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>41</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libutempter0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.6-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>107</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libuuid1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>39</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libva-drm1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.7.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>51</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libva-x11-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.7.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>157</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libva1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.7.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>253</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvdpau-va-gl1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>109</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvdpau1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.1-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>26</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libverto-libev1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.4-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>35</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libverto1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.4-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>380</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvisual-0.4-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.4.0-10</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>205</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvorbis0a</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.5-4+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>699</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvorbisenc2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.5-4+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>59</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvorbisfile3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.3.5-4+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2322</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libvpx4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.1-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>23</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwacom-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.22-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>458</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwacom-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.22-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>59</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwacom2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.22-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>198</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwavpack1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>5.0.0-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>80</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwayland-client0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>49</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwayland-cursor0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>70</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwayland-egl1-mesa</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>98</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwayland-server0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>462</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwebp6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.5.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>96</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwebpdemux2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.5.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>116</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwebpmux2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.5.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>709</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwebrtc-audio-processing1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>187</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwgdb0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.7.3-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>232</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-crt0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-crypto0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-dsparse0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>223</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-environment0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>227</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-file0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-handle0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-heap0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>244</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-input0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>223</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-interlocked0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-library0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-path0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>228</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-pool0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-registry0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>268</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-rpc0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>304</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-sspi0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>237</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-synch0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>222</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-sysinfo0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>223</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-thread0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>330</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwinpr-utils0.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1882</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwnck-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.30.7-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>339</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwnck22</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.30.7-5.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>104</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwrap0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>7.6.q-26</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>403</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwww-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.15-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>80</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libwww-robotrules-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>6.01-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1547</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx11-6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.6.4-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1665</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx11-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2:1.6.4-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>397</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx11-protocol-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.56-7</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx11-xcb1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.6.4-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2251</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx264-148</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:0.148.2748+git97eaef2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>10916</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libx265-95</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.1-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2563</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxapian30</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.4.3-2+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3294</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxatracker2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>61</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxau6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.0.8-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>515</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxaw7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.13-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>123</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-dri2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>113</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-dri3-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>231</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-glx0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>113</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-present0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>167</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-render0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>118</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-shape0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>117</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-shm0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>132</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-sync1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>57</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-util0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.3.8-3+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>137</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb-xfixes0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>283</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcb1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>36</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcomposite1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:0.4.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>73</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxcursor1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.14-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>35</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxdamage1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.4-2+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>53</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxdmcp6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.2-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>124</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxext6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.3.3-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>299</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4panel-2.0-4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4ui-1-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4ui-2-0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1625</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4ui-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>256</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4ui-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>75</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4util-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>543</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4util-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>123</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfce4util7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>152</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfconf-0-2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>4.12.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>53</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfixes3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:5.0.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>262</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfont1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>oldlibs</SYSTEM_CATEGORY>
      <VERSION>1:1.5.2-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>248</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfont2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:2.0.1-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>851</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxfreerdp-client1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.0~git20140921.1.440916e+dfsg1-13+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>122</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxft2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.3.2-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>136</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxi6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.7.9-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>39</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxinerama1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.1.3-1+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>300</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxkbcommon0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.7.1-2~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>180</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxkbfile1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.0.9-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>138</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxklavier16</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>5.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>577</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxml-parser-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>2.44-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>64</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxml-treepp-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.43-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>565</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxml-twig-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1:3.50-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>154</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxml-xpathengine-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.13-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2130</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxml2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.9.4+dfsg1-2.2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>136</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxmu6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.1.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>50</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxmuu1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.1.2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>104</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxpm4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:3.5.12-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>82</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxrandr2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.5.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>70</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxrender1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:0.9.10-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>36</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxres1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.7-1+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>26</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxshmfence1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.2-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>481</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxslt1.1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.1.29-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxss1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.2.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>477</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxt6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>135</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxtables12</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1.6.0+snapshot20161117-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>57</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxtst6</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.2.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>49</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxv1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>731</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxvidcore4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.3.4-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>66</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxvmc1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.0.10-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>54</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxxf86dga1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2:1.1.4-1+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>50</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libxxf86vm1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.1.4-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>196</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libyaml-libyaml-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.63-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>173</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libyaml-perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>1.21-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>168</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libzvbi-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>0.2.35-13</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>710</FILESIZE>
      <FROM>deb</FROM>
      <NAME>libzvbi0</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>0.2.35-13</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>664</FILESIZE>
      <FROM>deb</FROM>
      <NAME>light-locker</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.7.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>787</FILESIZE>
      <FROM>deb</FROM>
      <NAME>lightdm</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.18.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>558</FILESIZE>
      <FROM>deb</FROM>
      <NAME>lightdm-gtk-greeter</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2.0.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>61</FILESIZE>
      <FROM>deb</FROM>
      <NAME>linux-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>kernel</SYSTEM_CATEGORY>
      <VERSION>4.5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>185233</FILESIZE>
      <FROM>deb</FROM>
      <NAME>linux-image-4.9.0-3-amd64</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>kernel</SYSTEM_CATEGORY>
      <VERSION>4.9.30-2+deb9u5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>16</FILESIZE>
      <FROM>deb</FROM>
      <NAME>linux-image-amd64</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>kernel</SYSTEM_CATEGORY>
      <VERSION>4.9+80+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4519</FILESIZE>
      <FROM>deb</FROM>
      <NAME>linux-libc-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>4.9.110-3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>9245</FILESIZE>
      <FROM>deb</FROM>
      <NAME>locales</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>314</FILESIZE>
      <FROM>deb</FROM>
      <NAME>locate</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>4.6.0+git+20161106-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2747</FILESIZE>
      <FROM>deb</FROM>
      <NAME>login</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1:4.4-4.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>132</FILESIZE>
      <FROM>deb</FROM>
      <NAME>logrotate</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.11.0-0.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>49</FILESIZE>
      <FROM>deb</FROM>
      <NAME>lsb-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>9.20161125</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>62</FILESIZE>
      <FROM>deb</FROM>
      <NAME>lsb-release</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>9.20161125</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>440</FILESIZE>
      <FROM>deb</FROM>
      <NAME>lsof</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>4.89+dfsg-0.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1211</FILESIZE>
      <FROM>deb</FROM>
      <NAME>make</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>devel</SYSTEM_CATEGORY>
      <VERSION>4.1-9.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2231</FILESIZE>
      <FROM>deb</FROM>
      <NAME>man-db</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>2.7.6.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1422</FILESIZE>
      <FROM>deb</FROM>
      <NAME>manpages</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>4.10-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3734</FILESIZE>
      <FROM>deb</FROM>
      <NAME>manpages-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>4.10-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>183</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mawk</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>interpreters</SYSTEM_CATEGORY>
      <VERSION>1.3.3-17+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1431</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mc</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>3:4.8.18-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>5576</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mc-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>3:4.8.18-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>12997</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mesa-va-drivers</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>18772</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mesa-vdpau-drivers</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>13.0.6-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>110</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mime-support</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>3.60</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>444</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mount</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>220</FILESIZE>
      <FROM>deb</FROM>
      <NAME>multiarch-support</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>2.24-11+deb9u3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>28</FILESIZE>
      <FROM>deb</FROM>
      <NAME>mysql-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>database</SYSTEM_CATEGORY>
      <VERSION>5.8+1.0.2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2043</FILESIZE>
      <FROM>deb</FROM>
      <NAME>nano</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>editors</SYSTEM_CATEGORY>
      <VERSION>2.7.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>340</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ncurses-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>536</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ncurses-bin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4025</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ncurses-term</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>6.0+20161126-1+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>940</FILESIZE>
      <FROM>deb</FROM>
      <NAME>net-tools</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1.60+git20161116.90da8a0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>44</FILESIZE>
      <FROM>deb</FROM>
      <NAME>netbase</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>5.4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>137</FILESIZE>
      <FROM>deb</FROM>
      <NAME>netcat-traditional</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1.10-41+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>387</FILESIZE>
      <FROM>deb</FROM>
      <NAME>notification-daemon</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>3.20.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1340</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ntfs-3g</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>otherosfs</SYSTEM_CATEGORY>
      <VERSION>1:2016.2.22AR.1+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4106</FILESIZE>
      <FROM>deb</FROM>
      <NAME>openssh-client</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:7.4p1-10+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>883</FILESIZE>
      <FROM>deb</FROM>
      <NAME>openssh-server</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:7.4p1-10+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>106</FILESIZE>
      <FROM>deb</FROM>
      <NAME>openssh-sftp-server</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:7.4p1-10+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1244</FILESIZE>
      <FROM>deb</FROM>
      <NAME>openssl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.1.0f-3+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>5573</FILESIZE>
      <FROM>deb</FROM>
      <NAME>orage</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>100</FILESIZE>
      <FROM>deb</FROM>
      <NAME>os-prober</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.76~deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>278</FILESIZE>
      <FROM>deb</FROM>
      <NAME>parted</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.2-17</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2478</FILESIZE>
      <FROM>deb</FROM>
      <NAME>passwd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1:4.4-4.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>215</FILESIZE>
      <FROM>deb</FROM>
      <NAME>patch</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>vcs</SYSTEM_CATEGORY>
      <VERSION>2.7.5-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>923</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pavucontrol</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>sound</SYSTEM_CATEGORY>
      <VERSION>3.0-3.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1220</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pciutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1:3.5.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>651</FILESIZE>
      <FROM>deb</FROM>
      <NAME>perl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>5.24.1-3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>7551</FILESIZE>
      <FROM>deb</FROM>
      <NAME>perl-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>5.24.1-3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>17630</FILESIZE>
      <FROM>deb</FROM>
      <NAME>perl-modules-5.24</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>5.24.1-3+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>27</FILESIZE>
      <FROM>deb</FROM>
      <NAME>perl-openssl-defaults</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>99</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pinentry-curses</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.0.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>219</FILESIZE>
      <FROM>deb</FROM>
      <NAME>policykit-1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>0.105-18+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>12123</FILESIZE>
      <FROM>deb</FROM>
      <NAME>poppler-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>0.4.7-8</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>51</FILESIZE>
      <FROM>deb</FROM>
      <NAME>powermgmt-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.31+nmu1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>690</FILESIZE>
      <FROM>deb</FROM>
      <NAME>procps</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2:3.3.12-3+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>219</FILESIZE>
      <FROM>deb</FROM>
      <NAME>psutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>1.17.dfsg-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>601</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulse-xmpp-agent</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.0.0git20190321091856.84f5584-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>203072</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulse-xmpp-agent-deps</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.6git20180619164725.9212b24-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>17</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulse-xmpp-agent-scheduler-machine</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.9.6git20180912122936.e3c470b-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>236</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulse-xmppmaster-agentplugins</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.8git20180912172136.9f993d2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>211</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulseagent-plugins-machine</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.8git20180912172136.9f993d2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>5880</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulseaudio</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>sound</SYSTEM_CATEGORY>
      <VERSION>10.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>255</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pulseaudio-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>sound</SYSTEM_CATEGORY>
      <VERSION>10.0-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>20</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pyflakes</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>20</FILESIZE>
      <FROM>deb</FROM>
      <NAME>pyflakes3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>648</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>6</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-all</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>6</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-all-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>623</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-apt-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.4.0~beta3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>359</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-bs4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>4.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>179</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-cffi-backend</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.9.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>496</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-chardet</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.3.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>400</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-configparser</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.3.0r2-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>71</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-croniter</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.3.12-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1402</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-crypto</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.6.1-7</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1456</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-cryptography</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.7.1-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>232</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-dateutil</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.5.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>25</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-dbg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>debug</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>469</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-dbus</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.2.4-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>18</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>598</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-dnspython</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.15.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>218</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-enum34</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.1.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>974</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-gi</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.22.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>68</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-gnupg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.3.9-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>529</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-html5lib</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.999999999-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>271</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-idna</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.2-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>101</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-ipaddress</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.0.17-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>134</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-keyring</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>10.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>89</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-keyrings.alt</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3169</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-lxml</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.7.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>145</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>167</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-mysqldb</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.7-1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>89</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-mysqldb-dbg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>debug</SYSTEM_CATEGORY>
      <VERSION>1.3.7-1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>52</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-netifaces</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.10.4-0.1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>198</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-openssl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>16.2.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>655</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pip</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>9.0.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1593</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pip-whl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>9.0.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>540</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pkg-resources</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>33.1.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>631</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-psutil</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>5.0.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>340</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pyasn1</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.1.9-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>170</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pyasn1-modules</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.0.7-0.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>173</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pycurl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>7.43.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>246</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-pyflakes</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>511</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-requests</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.12.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>51</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-secretstorage</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.3.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1013</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-setuptools</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>33.1.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-six</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.10.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>1491</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-slixmpp</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.1-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>57</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-socks</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.6.5-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>124</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-tz</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2016.7-0.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>302</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-urllib3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.19.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>67</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.0.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>55</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-webencodings</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.5-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>211</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-wheel</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.29.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>191</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-xdg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.25-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>100</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python-zipfile2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.0.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>359</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python2.7</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>14521</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python2.7-dbg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>debug</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>297</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python2.7-dev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3816</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python2.7-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.7.13-2+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>67</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>631</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-apt</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.4.0~beta3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>410</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-chardet</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.0.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>261</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-dateutil</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.6.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>257</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-debian</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.1.30</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>35</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-debianbts</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.6.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>238</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-flake8</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.2.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>117</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-httplib2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.9.2+dfsg-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>38</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-mccabe</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>120</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>511</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-pkg-resources</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>33.1.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>146</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-pycodestyle</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.2.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>172</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-pycurl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>7.43.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>246</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-pyflakes</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.3.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>180</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-pysimplesoap</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.16-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>357</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-reportbug</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>7.1.7+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>507</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-requests</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.12.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>922</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-setuptools</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>33.1.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-six</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.10.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>53</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-syncthing</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>2.3.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>302</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3-urllib3</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>1.19.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>319</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3.5</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>9411</FILESIZE>
      <FROM>deb</FROM>
      <NAME>python3.5-minimal</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>3.5.3-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>89</FILESIZE>
      <FROM>deb</FROM>
      <NAME>readline-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>7.0-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>36</FILESIZE>
      <FROM>deb</FROM>
      <NAME>rename</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>perl</SYSTEM_CATEGORY>
      <VERSION>0.20-4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>257</FILESIZE>
      <FROM>deb</FROM>
      <NAME>reportbug</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>7.1.7+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>687</FILESIZE>
      <FROM>deb</FROM>
      <NAME>rsync</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>3.1.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1507</FILESIZE>
      <FROM>deb</FROM>
      <NAME>rsyslog</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>8.24.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>137</FILESIZE>
      <FROM>deb</FROM>
      <NAME>rtkit</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>0.11-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>799</FILESIZE>
      <FROM>deb</FROM>
      <NAME>sed</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>4.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>62</FILESIZE>
      <FROM>deb</FROM>
      <NAME>sensible-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.0.9+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>69</FILESIZE>
      <FROM>deb</FROM>
      <NAME>sgml-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>1.29</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>4666</FILESIZE>
      <FROM>deb</FROM>
      <NAME>shared-mime-info</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>misc</SYSTEM_CATEGORY>
      <VERSION>1.8-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2343</FILESIZE>
      <FROM>deb</FROM>
      <NAME>shorewall</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>5.0.15.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>185</FILESIZE>
      <FROM>deb</FROM>
      <NAME>shorewall-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>5.0.15.6-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3035</FILESIZE>
      <FROM>deb</FROM>
      <NAME>sudo</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>1.8.19p1-2.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>15901</FILESIZE>
      <FROM>deb</FROM>
      <NAME>syncthing</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>default</SYSTEM_CATEGORY>
      <VERSION>0.14.49</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>7930</FILESIZE>
      <FROM>deb</FROM>
      <NAME>syncthing-discosrv</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.14.18+dfsg1-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>90</FILESIZE>
      <FROM>deb</FROM>
      <NAME>syncthingmanager</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>python</SYSTEM_CATEGORY>
      <VERSION>0.1.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>9292</FILESIZE>
      <FROM>deb</FROM>
      <NAME>systemd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>106</FILESIZE>
      <FROM>deb</FROM>
      <NAME>systemd-sysv</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>110</FILESIZE>
      <FROM>deb</FROM>
      <NAME>sysvinit-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.88dsf-59.9</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>11068</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tango-icon-theme</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>0.8.90-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2770</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tar</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.29b-1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>6</FILESIZE>
      <FROM>deb</FROM>
      <NAME>task-english</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>tasks</SYSTEM_CATEGORY>
      <VERSION>3.39</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>6</FILESIZE>
      <FROM>deb</FROM>
      <NAME>task-ssh-server</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>tasks</SYSTEM_CATEGORY>
      <VERSION>3.39</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>374</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tasksel</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.39</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>213</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tasksel-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>3.39</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>92</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tcpd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>7.6.q-26</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>157</FILESIZE>
      <FROM>deb</FROM>
      <NAME>telnet</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>0.17-41</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>886</FILESIZE>
      <FROM>deb</FROM>
      <NAME>thunar</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>1.6.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4710</FILESIZE>
      <FROM>deb</FROM>
      <NAME>thunar-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>1.6.11-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1169</FILESIZE>
      <FROM>deb</FROM>
      <NAME>thunar-volman</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.8.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>154</FILESIZE>
      <FROM>deb</FROM>
      <NAME>traceroute</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>net</SYSTEM_CATEGORY>
      <VERSION>1:2.1.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>304</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tumbler</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.1.31-2+b3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>914</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tumbler-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.1.31-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3013</FILESIZE>
      <FROM>deb</FROM>
      <NAME>tzdata</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>2018e-0+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>191</FILESIZE>
      <FROM>deb</FROM>
      <NAME>ucf</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>3.0036</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>7064</FILESIZE>
      <FROM>deb</FROM>
      <NAME>udev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>232-25+deb9u4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2011</FILESIZE>
      <FROM>deb</FROM>
      <NAME>udisks2</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>2.1.8-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>534</FILESIZE>
      <FROM>deb</FROM>
      <NAME>unzip</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>6.0-21</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>383</FILESIZE>
      <FROM>deb</FROM>
      <NAME>upower</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>admin</SYSTEM_CATEGORY>
      <VERSION>0.99.4-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>102</FILESIZE>
      <FROM>deb</FROM>
      <NAME>usbmuxd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.1.0-2+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>721</FILESIZE>
      <FROM>deb</FROM>
      <NAME>usbutils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1:007-4+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3558</FILESIZE>
      <FROM>deb</FROM>
      <NAME>util-linux</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>6169</FILESIZE>
      <FROM>deb</FROM>
      <NAME>util-linux-locales</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>localization</SYSTEM_CATEGORY>
      <VERSION>2.29.2-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>22</FILESIZE>
      <FROM>deb</FROM>
      <NAME>va-driver-all</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>video</SYSTEM_CATEGORY>
      <VERSION>1.7.3-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>30</FILESIZE>
      <FROM>deb</FROM>
      <NAME>vdpau-driver-all</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>video</SYSTEM_CATEGORY>
      <VERSION>1.1.1-6</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>275</FILESIZE>
      <FROM>deb</FROM>
      <NAME>vim-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>editors</SYSTEM_CATEGORY>
      <VERSION>2:8.0.0197-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1067</FILESIZE>
      <FROM>deb</FROM>
      <NAME>vim-tiny</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>editors</SYSTEM_CATEGORY>
      <VERSION>2:8.0.0197-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>990</FILESIZE>
      <FROM>deb</FROM>
      <NAME>wamerican</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>7.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2747</FILESIZE>
      <FROM>deb</FROM>
      <NAME>wget</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>web</SYSTEM_CATEGORY>
      <VERSION>1.18-5+deb9u2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>69</FILESIZE>
      <FROM>deb</FROM>
      <NAME>whiptail</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.52.19-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2330</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-apps</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>7.7+6+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>305</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>219</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-session-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>7.7+2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>637</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>7.7+3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>455</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-xkb-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>7.7+3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>516</FILESIZE>
      <FROM>deb</FROM>
      <NAME>x11-xserver-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>7.7+7+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>82</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xauth</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:1.0.9-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>223</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xbitmaps</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.1.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>360</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xdg-user-dirs</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>0.15-2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>306</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xdg-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>1.1.1-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>16</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1068</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-appfinder</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>497</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-notifyd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.3.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3348</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-panel</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>141</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-pulseaudio-plugin</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>0.2.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2343</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-session</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2810</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfce4-settings</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>706</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfconf</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>523</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfdesktop4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.3-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2079</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfdesktop4-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.3-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>4101</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-100dpi</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:1.0.4+nmu1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>3689</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-75dpi</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:1.0.4+nmu1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>7166</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-base</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:1.0.4+nmu1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>668</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-encodings</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:1.0.4-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>467</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-scalable</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>fonts</SYSTEM_CATEGORY>
      <VERSION>1:1.0.3-1.1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>387</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfonts-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+4</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2921</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xfwm4</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>xfce</SYSTEM_CATEGORY>
      <VERSION>4.12.4-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>83</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xinit</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.3.4-3+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>5774</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xkb-data</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2.19-1+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>117</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xml-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>text</SYSTEM_CATEGORY>
      <VERSION>0.17</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>52</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xorg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>109</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xorg-docs-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>doc</SYSTEM_CATEGORY>
      <VERSION>1:1.7.1-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>all</ARCH>
      <FILESIZE>2128</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-common</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2:1.19.2-1+deb9u5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>238</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>5805</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-core</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2:1.19.2-1+deb9u5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>46</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-input-all</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>117</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-input-libinput</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>0.23.0-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>279</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-input-wacom</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>0.34.0-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>2155</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-legacy</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2:1.19.2-1+deb9u5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>46</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-all</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.7+19</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>201</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-amdgpu</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1.2.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>352</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-ati</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.8.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>56</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-fbdev</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:0.4.4-1+b5</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>3198</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-intel</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>2:2.99.917+git20161206-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>458</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-nouveau</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:1.0.13-3</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>258</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-qxl</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>0.1.4+20161126git4d7160c-1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>825</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-radeon</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:7.8.0-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>65</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-vesa</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:2.3.4-1+b2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>243</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xserver-xorg-video-vmware</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>1:13.2.1-1+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>1872</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xterm</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>x11</SYSTEM_CATEGORY>
      <VERSION>327-2</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>167</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xxd</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>editors</SYSTEM_CATEGORY>
      <VERSION>2:8.0.0197-4+deb9u1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>516</FILESIZE>
      <FROM>deb</FROM>
      <NAME>xz-utils</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>utils</SYSTEM_CATEGORY>
      <VERSION>5.2.2-1.2+b1</VERSION>
    </SOFTWARES>
    <SOFTWARES>
      <ARCH>amd64</ARCH>
      <FILESIZE>156</FILESIZE>
      <FROM>deb</FROM>
      <NAME>zlib1g</NAME>
      <PUBLISHER>Debian</PUBLISHER>
      <SYSTEM_CATEGORY>libs</SYSTEM_CATEGORY>
      <VERSION>1:1.2.8.dfsg-5</VERSION>
    </SOFTWARES>
    <STORAGES>
      <DESCRIPTION>SATA</DESCRIPTION>
      <DISKSIZE>31457</DISKSIZE>
      <FIRMWARE>10</FIRMWARE>
      <MANUFACTURER>VBOX HARDDISK</MANUFACTURER>
      <MODEL>VBOX HARDDISK</MODEL>
      <NAME>sda</NAME>
      <SERIALNUMBER>VB76000c25-1c68e2c4</SERIALNUMBER>
      <TYPE>disk</TYPE>
    </STORAGES>
    <USERS>
      <LOGIN>root</LOGIN>
    </USERS>
    <VERSIONCLIENT>FusionInventory-Agent_v2.4-2</VERSIONCLIENT>
    <VERSIONPROVIDER>
      <COMMENTS>Build platform: Debian Linux dev 66d9e9f6</COMMENTS>
      <COMMENTS>Build date: Fri Jan 26 14:07:31 UTC 2018</COMMENTS>
      <NAME>FusionInventory</NAME>
      <PERL_EXE>/usr/bin/perl</PERL_EXE>
      <PERL_VERSION>v5.24.1</PERL_VERSION>
      <PROGRAM>/usr/bin/fusioninventory-agent</PROGRAM>
      <VERSION>2.4-2</VERSION>
    </VERSIONPROVIDER>
  </CONTENT>
  <DEVICEID>MACHINE_TEST_BENCKMARK-2018-05-15-16-02-53</DEVICEID>
  <QUERY>INVENTORY</QUERY>
</REQUEST>
"""


def file_get_contents(filename, use_include_path=0, context=None, offset=-1, maxlen=-1):
    """
    load content file or simple url
    """
    if filename.find("://") > 0:
        ret = urllib.request.urlopen(filename).read()
        if offset > 0:
            ret = ret[offset:]
        if maxlen > 0:
            ret = ret[:maxlen]
        return ret
    else:
        fp = open(filename, "r")
        try:
            if offset > 0:
                fp.seek(offset)
            ret = fp.read(maxlen)
            return ret
        finally:
            fp.close()


def file_get_binarycontents(filename, offset=-1, maxlen=-1):
    fp = open(filename, "rb")
    try:
        if offset > 0:
            fp.seek(offset)
        ret = fp.read(maxlen)
        return ret
    finally:
        fp.close()


def file_put_contents_w_a(filename, data, option="w"):
    if option == "a" or option == "w":
        f = open(filename, option)
        f.write(data)
        f.close()


def file_put_contents(filename, data):
    """
    write content "data" to file "filename"
    """
    f = open(filename, "w")
    f.write(data)
    f.close()


def add_coloring_to_emit_windows(fn):
    # add methods we need to the class
    # def _out_handle(self):
    # import ctypes
    # return ctypes.windll.kernel32.GetStdHandle(self.STD_OUTPUT_HANDLE)
    # out_handle = property(_out_handle)

    def _set_color(self, code):
        import ctypes

        # Constants from the Windows API
        self.STD_OUTPUT_HANDLE = -11
        hdl = ctypes.windll.kernel32.GetStdHandle(self.STD_OUTPUT_HANDLE)
        ctypes.windll.kernel32.SetConsoleTextAttribute(hdl, code)

    setattr(logging.StreamHandler, "_set_color", _set_color)

    def new(*args):
        FOREGROUND_BLUE = 0x0001  # text color contains blue.
        FOREGROUND_GREEN = 0x0002  # text color contains green.
        FOREGROUND_RED = 0x0004  # text color contains red.
        FOREGROUND_INTENSITY = 0x0008  # text color is intensified.
        FOREGROUND_WHITE = FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED
        # winbase.h
        # STD_INPUT_HANDLE = -10
        # STD_OUTPUT_HANDLE = -11
        # STD_ERROR_HANDLE = -12

        # wincon.h
        # FOREGROUND_BLACK     = 0x0000
        FOREGROUND_BLUE = 0x0001
        FOREGROUND_GREEN = 0x0002
        # FOREGROUND_CYAN      = 0x0003
        FOREGROUND_RED = 0x0004
        FOREGROUND_MAGENTA = 0x0005
        FOREGROUND_YELLOW = 0x0006
        # FOREGROUND_GREY      = 0x0007
        FOREGROUND_INTENSITY = 0x0008  # foreground color is intensified.

        # BACKGROUND_BLACK     = 0x0000
        # BACKGROUND_BLUE      = 0x0010
        # BACKGROUND_GREEN     = 0x0020
        # BACKGROUND_CYAN      = 0x0030
        # BACKGROUND_RED       = 0x0040
        # BACKGROUND_MAGENTA   = 0x0050
        BACKGROUND_YELLOW = 0x0060
        # BACKGROUND_GREY      = 0x0070
        BACKGROUND_INTENSITY = 0x0080  # background color is intensified.

        levelno = args[1].levelno
        if levelno >= 50:
            color = (
                BACKGROUND_YELLOW
                | FOREGROUND_RED
                | FOREGROUND_INTENSITY
                | BACKGROUND_INTENSITY
            )
        elif levelno >= 40:
            color = FOREGROUND_RED | FOREGROUND_INTENSITY
        elif levelno >= 30:
            color = FOREGROUND_YELLOW | FOREGROUND_INTENSITY
        elif levelno >= 20:
            color = FOREGROUND_GREEN
        elif levelno >= 10:
            color = FOREGROUND_MAGENTA
        else:
            color = FOREGROUND_WHITE
        args[0]._set_color(color)

        ret = fn(*args)
        args[0]._set_color(FOREGROUND_WHITE)
        # print "after"
        return ret

    return new


def add_coloring_to_emit_ansi(fn):
    # add methods we need to the class
    def new(*args):
        levelno = args[1].levelno
        if levelno >= 50:
            color = "\x1b[31m"  # red
        elif levelno >= 40:
            color = "\x1b[31m"  # red
        elif levelno >= 30:
            color = "\x1b[33m"  # yellow
        elif levelno >= 20:
            color = "\x1b[32m"  # green
        elif levelno >= 10:
            color = "\x1b[35m"  # pink
        else:
            color = "\x1b[0m"  # normal
        args[1].msg = color + str(args[1].msg) + "\x1b[0m"  # normal
        # print "after"
        return fn(*args)

    return new


class StreamToLogger(object):
    """
    Fake file-like stream object that redirects writes to a logger instance.
    """

    def __init__(self, logger, debug=logging.INFO):
        self.logger = logger
        self.debug = debug
        self.linebuf = ""

    def write(self, buf):
        for line in buf.rstrip().splitlines():
            self.logger.log(self.debug, line.rstrip())


class configuration:
    def __init__(self, fileconf=None):
        self.fileconf = fileconf
        self.Password = "password"
        self.Port = 5222
        self.Server = "192.168.56.2"
        self._config = False
        self.Agentname = "injectinventory"
        self.Domain = "pulse"
        self.log_level = "INFO"
        self.Jid = "%s@%s" % (self.Agentname, self.Domain)
        self.Url = "http://localhost:9999/"
        Config = configparser.ConfigParser()
        if fileconf is None:
            if os.path.exists("/etc/mmc/plugins/xmppmaster.ini"):
                Config.read("/etc/mmc/plugins/xmppmaster.ini")
                if os.path.exists("/etc/mmc/plugins/xmppmaster.ini.local"):
                    Config.read("/etc/mmc/plugins/xmppmaster.ini.local")
                self._config = True

        elif os.path.exists(fileconf):
            Config.read(fileconf)
            if os.path.exists(fileconf + ".local"):
                Config.read(fileconf + ".local")
            self._config = True
        else:
            print("error no file configuration")
            self._config = False
        if self._config:
            self.charge_conf(Config)

    def charge_conf(self, Config):
        # if  Config.has_option("connection", "password"):
        # self.Password=Config.get('connection', 'password')

        # if  Config.has_option("connection", "port"):
        # self.Port = Config.get('connection', 'port')

        # if  Config.has_option("connection", "server"):
        # self.Server=Config.get('connection', 'server')

        # if  Config.has_option("connection", "agentname"):
        # self.Agentname=Config.get('connection', 'agentname')

        # if  Config.has_option("connection", "domain"):
        # self.Domain=Config.get('connection', 'domain')

        if Config.has_option("global", "log_level"):
            self.log_level = Config.get("global", "log_level")

        if Config.has_option("inventory", "url"):
            self.Url = Config.get("inventory", "url")

        if Config.has_option("inventory", "nbthreadmax"):
            self.nbthreadmax = Config.get("inventory", "nbthreadmax")
        else:
            self.nbthreadmax = None

        # self.Jid = "%s@%s"%(self.Agentname, self.Domain,)

        # global
        if self.log_level == "INFO":
            self.debug = logging.INFO
        elif self.log_level == "DEBUG":
            self.debug = logging.DEBUG
        elif self.log_level == "ERROR":
            self.debug = logging.ERROR
        else:
            self.debug = 5

    def getRandomName(self, nb, pref=""):
        a = "abcdefghijklnmopqrstuvwxyz"
        d = pref
        for t in range(nb):
            d = d + a[random.randint(0, 25)]
        return d

    def getRandomNameID(self, nb, pref=""):
        a = "0123456789"
        d = pref
        for t in range(nb):
            d = d + a[random.randint(0, 9)]
        return d

    def get_local_ip_adresses(self):
        ip_addresses = list()
        interfaces = netifaces.interfaces()
        for i in interfaces:
            if i == "lo":
                continue
            iface = netifaces.ifaddresses(i).get(netifaces.AF_INET)
            if iface:
                for j in iface:
                    addr = j["addr"]
                    if addr != "127.0.0.1":
                        ip_addresses.append(addr)
        return ip_addresses

    # def __str__(self):
    # return str(self.re)

    def jsonobj(self):
        return json.dumps(self.re)


def getRandomName(nb, pref=""):
    a = "abcdefghijklnmopqrstuvwxyz0123456789"
    d = pref
    for t in range(nb):
        d = d + a[random.randint(0, 35)]
    return d


def md5(fname):
    hash = hashlib.md5()
    with open(fname, "rb") as f:
        for chunk in iter(lambda: f.read(4096), b""):
            hash.update(chunk)
    return hash.hexdigest()


class action(Thread):

    """Thread chargé simplement d'afficher un mot dans la console."""

    def __init__(self, content, HEADER, url):
        Thread.__init__(self)
        global nbthread
        nbthread += 1
        self.HEADER = HEADER
        self.content = content
        self.url = url

    def run(self):
        """Code à exécuter pendant l'exécution du thread."""
        global nbthread
        try:
            print(self.url)
            request = urllib.request.Request(self.url, self.content, self.HEADER)
            response = urllib.request.urlopen(request)
        except Exception as exc:
            logger.warning("Unable to send inventory to GLPI")
            logger.warning("Response was: %s" % str(exc))
        nbthread -= 1


class actiontest(Thread):

    """Thread chargé simplement d'afficher un mot dans la console."""

    def __init__(self, HEADER, url, number=0):
        Thread.__init__(self)
        self.HEADER = HEADER
        self.url = url
        self.number = number

    def run(self):
        """Code à exécuter pendant l'exécution du thread."""
        global nbthread
        global maxthread
        try:
            g = time.time()
            d = nbthread
            nbthread += 1
            d += 1
            if maxthread < d:
                maxthread = d

            request = urllib.request.Request(self.url, globaltest, self.HEADER)
            response = urllib.request.urlopen(request)
        except Exception as exc:
            logger.warning("Unable to send inventory to GLPI")
            logger.warning("Response was: %s" % str(exc))
        end = time.time()
        nbthread -= 1
        print(
            "Thread %d nbrmax %s inventory %s start %s end %s duration %s"
            % (d, maxthread, self.number, g, end, end - g)
        )


class inventoryinject:
    def __init__(self, conf):
        self.conf = conf
        if conf.testmode:
            logger.warning("time interval is %s" % self.conf.nbmessagebyseconde)
        self.dirinventory = os.path.join(
            "/",
            "usr",
            "lib",
            "python2.7",
            "dist-packages",
            "mmc",
            "plugins",
            "xmppmaster",
            "master",
            "RecvInventory",
        )
        self.stop = False
        self.listfilename = []
        self.HEADER = {
            "Pragma": "no-cache",
            "User-Agent": "Proxy:FusionInventory/Pulse2/GLPI",
            "Content-Type": "application/x-compress",
        }
        if self.conf.Url is not None:
            self.url = self.conf.Url
        else:
            self.url = "http://localhost:9999/"

        signal.signal(signal.SIGINT, self.signal_handler)
        pass

    def signal_handler(self, signal, frame):
        self.stop = True

    # lecture des fichiers namefichier inventory.
    def load_file_name(self):
        # print "Load"
        # self.listpriotity = [x for x in os.listdir(self.dirinventory) if x[-4:] == ".inv"]
        self.listfilename = [
            x for x in os.listdir(self.dirinventory) if x[-4:] == ".xml"
        ]
        # for element in self.listfilename:
        # print element
        return self.listfilename

    def injectinventory(self, filenameinjectxml="", number=0):
        if not self.conf.testmode:
            if filenameinjectxml == "":
                logger.error("error name file")
                return
            namefileinject = os.path.join(self.dirinventory, filenameinjectxml)
            content = file_get_contents(namefileinject)
            os.remove(namefileinject)
            thread_1 = action(content, self.HEADER, self.url).start()
        else:
            thread_1 = actiontest(self.HEADER, self.url, number).start()

    def execprog(self):
        global nbthread
        if not self.conf.testmode:
            self.load_file_name()

            while not self.stop:
                if nbthread < self.conf.nbthreadmax:
                    # print "nb maximun permit de thread %s"%self.conf.nbthreadmax
                    # print "nbthread en cours %s"%nbthread
                    # print "nb fichier a traiter %s"%len(self.listfilename)
                    if len(self.listfilename) > 0:
                        try:
                            filenameinject = self.listfilename.pop(0)
                            self.injectinventory(filenameinject)
                        except Exception as e:
                            logger.error(str(e))
                        if self.conf.nbmessagebyseconde is not None:
                            time.sleep(self.conf.nbmessagebyseconde)
                    else:
                        self.load_file_name()
                else:
                    time.sleep(0.01)
        else:
            for i in range(self.conf.Numbercycles):
                self.injectinventory(filenameinjectxml="", number=i)
                if self.conf.nbmessagebyseconde is not None:
                    time.sleep(self.conf.nbmessagebyseconde)
                if self.stop:
                    break
        # 2 secondes for terminate
        time.sleep(2)


def createDaemon(opts, conf):
    """
    This function create a service/Daemon that will execute a det. task
    """
    try:
        pid = os.fork()
        if pid > 0:
            print("PID: %d" % pid)
            os._exit(0)
        doTask(opts, conf)
    except OSError as error:
        logging.error("Unable to fork. Error: %d (%s)" % (error.errno, error.strerror))
        logger.error("\n%s" % (traceback.format_exc()))
        os._exit(1)


def doTask(opts, conf):
    logging.StreamHandler.emit = add_coloring_to_emit_ansi(logging.StreamHandler.emit)
    # logging.basicConfig(level = logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')
    if opts.consoledebug:
        logging.basicConfig(
            level=logging.DEBUG, format="%(asctime)s - %(levelname)s - %(message)s"
        )
    else:
        stdout_logger = logging.getLogger("STDOUT")
        sl = StreamToLogger(stdout_logger, logging.INFO)
        sys.stdout = sl
        stderr_logger = logging.getLogger("STDERR")
        sl = StreamToLogger(stderr_logger, logging.INFO)
        sys.stderr = sl
        logging.basicConfig(
            level=logging.INFO,
            format="[%(name)s.%(funcName)s:%(lineno)d] %(message)s",
            filename="/var/log/pulse/xmpp-agent-log.log",
            filemode="a",
        )
    # start programme
    if conf.testmode:
        startprog = time.time()
        print("nb injection %s" % conf.Numbercycles)
        print("START %s" % startprog)
        print("--------------------------")
    prog = inventoryinject(conf)
    prog.execprog()
    if conf.testmode:
        print("--------------------------")
        end = time.time()
        print("STOP %s" % end)
        duration = end - startprog
        print("Duration %s" % (duration))
        print("real nb/s %s" % (duration / conf.Numbercycles))
        print("interval is %s" % prog.conf.nbmessagebyseconde)


if __name__ == "__main__":
    if not sys.platform.startswith("linux"):
        print("Agent log on systeme linux only")
    if os.getuid() != 0:
        print("Agent must be running as root")
        sys.exit(0)

    optp = OptionParser()
    optp.add_option(
        "-d",
        "--deamon",
        action="store_true",
        dest="deamon",
        default=False,
        help="deamonize process",
    )

    optp.add_option(
        "-c",
        "--consoledebug",
        action="store_true",
        dest="consoledebug",
        default=False,
        help="console debug",
    )

    optp.add_option(
        "-n",
        "--numberbyseconde",
        dest="numberbyseconde",
        default=None,
        help="nombre d inventaire par seconde",
    )

    optp.add_option(
        "-s",
        "--intertime",
        dest="intertime",
        default=None,
        help="time between 2 inventory",
    )

    optp.add_option(
        "-t",
        "--testmode",
        action="store_true",
        dest="testmode",
        default=False,
        help="send inventory of test",
    )

    optp.add_option(
        "-m",
        "--numbercycles",
        dest="numbercycles",
        default=None,
        help="number total inventory inject",
    )

    optp.add_option(
        "-f", "--fichierconf", dest="fichierconf", default="100", help="fichierconf"
    )

    optp.add_option(
        "-T",
        "--nbthreadmax",
        dest="nbthreadmax",
        default=None,
        help="nomber thread maximun",
    )

    # optp.add_option("-p", "--password",
    # dest="password", default=None,
    # help="password connection xmpp")

    # optp.add_option("-P", "--port",
    # dest="port" default=None,
    # help="port connection xmpp")

    # optp.add_option("-S", "--server",
    # dest="server" default=None,
    # help="Server ip connection xmpp")

    # optp.add_option("-J", "--jid",
    # dest="jid" default=None,
    # help="Jid agent connection xmpp")

    optp.add_option(
        "-U", "--url", dest="url", default=None, help="url connection inventory server"
    )

    opts, args = optp.parse_args()

    # Setup the command line arguments.
    conf = configuration()
    if conf._config:
        pass

    if opts.url is not None:
        conf.Url = opts.url

    # if opts.jid != None:
    # conf.Jid = opts.jid

    # if opts.password != None:
    # conf.Password = str(opts.password)

    # if opts.port != None:
    # conf.Port = int(opts.port)

    # if opts.server != None:
    # conf.Server = str(opts.server)

    if opts.numberbyseconde is not None:
        conf.Nbmessage = float(opts.numberbyseconde)
    else:
        conf.Nbmessage = None

    if opts.intertime is not None:
        conf.Intertime = float(opts.intertime)
    else:
        conf.Intertime = None

    if opts.numbercycles is not None:
        conf.Numbercycles = int(opts.numbercycles)
    else:
        conf.Numbercycles = 100

    conf.testmode = opts.testmode

    if opts.nbthreadmax is not None:
        conf.nbthreadmax = int(opts.nbthreadmax)
    elif conf.nbthreadmax is not None:
        conf.nbthreadmax = int(conf.nbthreadmax)

    conf.Testmode = bool(opts.testmode)

    if conf.Intertime is not None:
        conf.nbmessagebyseconde = float(conf.Intertime)
    elif conf.Nbmessage is not None:
        conf.nbmessagebyseconde = float(1 / conf.Nbmessage)
    else:
        conf.nbmessagebyseconde = None

    if not opts.deamon:
        doTask(opts, conf)
    else:
        createDaemon(opts, conf)
